Package com.io7m.waxmill.cmdline.internal

# Class WXMNamedParameter.Builder<T>

java.lang.Object
com.io7m.waxmill.cmdline.internal.WXMNamedParameter.Builder<T>

Enclosing class:
  WXMNamedParameter<T>

    public static final class WXMNamedParameter.Builder<T>
    extends java.lang.Object

Builds instances of type `WXMNamedParameter`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `WXMNamedParameter<T>` | `build()` | Builds a new `WXMNamedParameter`.
  `WXMNamedParameter.Builder<T>` | `from​(WXMNamedParameterType<T> instance)` | Fill a builder with attribute values from the provided `WXMNamedParameterType` instance.
  `WXMNamedParameter.Builder<T>` | `setName​(java.lang.String name)` | Initializes the value for the `name` attribute.
  `WXMNamedParameter.Builder<T>` | `setValue​(T value)` | Initializes the value for the `value` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final WXMNamedParameter.Builder<T> from​(WXMNamedParameterType<T> instance)
    Fill a builder with attribute values from the provided `WXMNamedParameterType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setName

    public final WXMNamedParameter.Builder<T> setName​(java.lang.String name)
    Initializes the value for the `name` attribute.
    Parameters:
      `name` - The value for name
    Returns:
      `this` builder for use in a chained invocation

  - ### setValue

    public final WXMNamedParameter.Builder<T> setValue​(T value)
    Initializes the value for the `value` attribute.
    Parameters:
      `value` - The value for value
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public WXMNamedParameter<T> build()
    Builds a new `WXMNamedParameter`.
    Returns:
      An immutable instance of WXMNamedParameter
    Throws:
      `java.lang.IllegalStateException` - if any required attributes are missing